<template>
  <div class="collapse" ref="filterCollapsePanel">
    <div class="card card-body">
      <div class="container">
        <div class="row">
          <div class="col">
            <checkbox-filter
              class="mt-4 mb-3"
              store_method="SET_FILTER_RETAINS_COPYRIGHT"
              journal_prop_name="copyright_author_retains">{{ $t('searchfilter.retain_copyright') }}</checkbox-filter>
            <slider-filter
              class="mt-4 mb-3"
              store_method="SET_FILTER_PUBLICATION_TIME"
              :unit="$t('general.pub_time_unit')"
              filter_name="publication_time"
              max_getter="publication_time_max"><b>{{ $t('searchfilter.publication_time') }}</b></slider-filter>
            <slider-filter
              class="mt-4 mb-3"
              store_method="SET_FILTER_APCS"
              filter_name="apc"
              unit="€"
              max_getter="apcs_max"
              :step_size="100"
              :min="0"><b>{{ $t('searchfilter.apcs') }}</b></slider-filter>
            <subject-selection-filter class="mt-4 mb-3"><b>{{ $t('searchfilter.subject') }}</b><tooltip-help :text="$t('searchfilter.subject_help')" /></subject-selection-filter>
            <language-filter mt-4 mb-3><b>{{ $t('searchfilter.language') }}</b></language-filter>
          </div>
          <div class="col">
            <keyword-filter class="mt-4 mb-3"><b>{{ $t('searchfilter.keywords') }}</b><tooltip-help :text="$t('searchfilter.keyword_help')" /></keyword-filter>
            <button type="button" class="float-end btn btn-danger" @click="reset_filters">✖ {{ $t('searchfilter.reset') }}</button>
            <transition name="fade">
              <div v-show="filtersChanged" class="spinner-border me-3 float-end" role="status">
                <span class="visually-hidden">Loading...</span>
              </div>
            </transition>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import CheckboxFilter from './filters/CheckboxFilter.vue'
import SliderFilter from './filters/SliderFilter.vue'
import SubjectSelectionFilter from './filters/SubjectSelectionFilter.vue'
import KeywordFilter from './filters/KeywordFilter.vue'
import LanguageFilter from './filters/LanguageFilter.vue'
import TooltipHelp from './TooltipHelp.vue'
import { Collapse } from 'bootstrap'

export default {
  name: 'SearchFilterBox',
  components: {
    CheckboxFilter,
    SliderFilter,
    SubjectSelectionFilter,
    KeywordFilter,
    LanguageFilter,
    TooltipHelp
  },
  data () {
    return {
      filterCollapse: null,
      observer: new MutationObserver(mutations => {
        this.$store.commit('SET_FILTER_VISIBLE', this.filterCollapse._isShown())
      }),
      filtersChanged: false,
      filtersChangedTime: new Date()
    }
  },
  methods: {
    reset_filters () {
      this.$store.commit('RESET_FILTERS', this.$store.getters.reset_filter_values)
    }
  },
  computed: {
    state () {
      return this.$store.state.state
    },
    filters () {
      return this.$store.state.filters
    }
  },
  mounted () {
    const toggled = this.$store.state.filters.visible
    this.filterCollapse = new Collapse(this.$refs.filterCollapsePanel, { toggle: false })
    if (toggled) {
      // if the collapse is toggled in constructor there is an animation so we do
      // use css classes
      this.$refs.filterCollapsePanel.classList.add('show')
      // correct the scroll position. Otherwise the collapse will add its height
      // to the scroll position
      window.scrollTo(this.$router.options.history.state.scroll)
    }

    // observe resize changes to check whether filter become visible and store
    // changes in vuex
    this.observer.observe(this.$refs.filterCollapsePanel, {
      attributes: true,
      attributeFilter: ['class']
    })
  },
  beforeUnmount () {
    this.observer.disconnect()
  },
  watch: {
    state (newValue) {
      this.filterDisabled = newValue !== 'RESULTS' || this.$store.state.journals.length === 0
      if (newValue !== 'RESULTS' && this.filterCollapse !== null) {
        this.filterCollapse.hide()
      }
    },
    filters: {
      deep: true,
      handler () {
        // watch for changes to activate spinner
        this.filtersChanged = true
        this.filtersChangedTime = new Date()
        const self = this
        setTimeout(function () {
          if ((new Date() - self.filtersChangedTime) > 500) {
            self.filtersChanged = false
          }
        }, 700)
      }
    }
  }
}
</script>

<style scoped>
.fade-leave-active {
  transition: opacity 1s;
}
.fade-leave-to {
  opacity: 0;
}
</style>
